#!/bin/sh
# Copyright (C) 2015 J05HYYY

askForToolChainConfig(){
if [ -z "$1" ]; then #if hasn't already been specified.
echo "Please type a number or type the name of the toolchain configuration you'd like to use."
read selectedToolchainConfig
	if [ `expr $selectedToolchainConfig + 1 2> /dev/null` ]; then #if it's a numeric value
		eval selectedToolchainConfig="\$array$selectedToolchainConfig"
	fi
else
selectedToolchainConfig="$1"
fi

selectedToolchainConfigPath="samples/$selectedToolchainConfig/crosstool.config"

if [ ! -f "$selectedToolchainConfigPath" ]; then #if file exists
echo "Unrecognised toolchain configuration."
askForToolChainConfig $1
fi
}

configureForKernel(){
#$1 toolchain configuration
#$2 kernel path

if [ $# -lt 1 ]; then #if hasn't already been specified.
echo "No kernel sources specified."
exit
fi;

cd crosstool-ng*/samples/

#store in array
numOfTypes=0 # number of types of toolchain configuration.
for toolchainConfig in `ls -d */`
do
	length=`expr length $toolchainConfig`
	length=`expr $length - 1`
	toolchainConfig=`echo "$toolchainConfig" | cut -c -$length`
	eval array$numOfTypes="$toolchainConfig"
	if [ -z "$1" ]; then #if hasn't already been specified.
		eval echo "[$numOfTypes] \$array$numOfTypes"
	fi
	numOfTypes=`expr $numOfTypes + 1`
done

cd ..

askForToolChainConfig $1

if [ -z "$2" ]; then #if no custom kernel
echo "CT_KERNEL_LINUX_CUSTOM_LOCATION=\"$2\"" >> samples/$1/crosstool.config
fi

./ct-ng $selectedToolchainConfig

cd ..
}
